Blob


1 #!/bin/sh
2 #
3 # Copyright (c) 2019, 2020 Stefan Sperling <stsp@openbsd.org>
4 #
5 # Permission to use, copy, modify, and distribute this software for any
6 # purpose with or without fee is hereby granted, provided that the above
7 # copyright notice and this permission notice appear in all copies.
8 #
9 # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
10 # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
11 # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
12 # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
13 # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
14 # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
15 # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
17 export GIT_AUTHOR_NAME="Flan Hacker"
18 export GIT_AUTHOR_EMAIL="flan_hacker@openbsd.org"
19 export GIT_COMMITTER_NAME="$GIT_AUTHOR_NAME"
20 export GIT_COMMITTER_EMAIL="$GIT_AUTHOR_EMAIL"
21 export GOT_AUTHOR="$GIT_AUTHOR_NAME <$GIT_AUTHOR_EMAIL>"
22 export GOT_AUTHOR_8="flan_hac"
23 export GOT_AUTHOR_11="flan_hacker"
24 export GOT_LOG_DEFAULT_LIMIT=0
25 export GOT_TEST_ROOT="/tmp"
27 export MALLOC_OPTIONS=S
29 date()
30 {
31 DATECMD="date"
32 [ "$PLATFORM" != "linux" ] && DATECMD="gdate"
34 command "$DATECMD" "$@"
35 }
37 ln()
38 {
39 LNCMD="ln"
40 [ "$PLATFORM" != "linux" ] && LNCMD="gln"
42 command "$LNCMD" "$@"
43 }
45 sed()
46 {
47 SEDCMD="sed"
48 [ "$PLATFORM" = "linux" ] && {
49 set -- "$@"
50 [ $# -ge 4 ] && {
51 shift 2
53 command "$SEDCMD" -i "$@"
54 return
55 }
56 }
57 command "$SEDCMD" "$@"
58 }
61 git_init()
62 {
63 git init -q "$1"
65 # Switch the default branch to match our test expectations if needed.
66 # Only need to change HEAD since 'git init' did not create any refs.
67 # Relying on implementation details of 'git init' is no problem for us.
68 # We want to be alerted when Git changes fundamental assumptions such
69 # as what an empty repository looks like and where the default branch
70 # is set. In such cases Got's own tooling might well need to change
71 # its behaviour, too, and our tests should fail.
72 # TODO: Update all tests to assume 'main' instead of 'master' and
73 # switch to main here, to match Got's own default.
74 echo "ref: refs/heads/master" > "$1/.git/HEAD"
75 }
77 maybe_pack_repo()
78 {
79 local repo="$1"
80 if [ -n "$GOT_TEST_PACK" ]; then
81 (cd $repo && git repack -a -q)
82 fi
83 }
85 git_commit()
86 {
87 local repo="$1"
88 shift
89 (cd $repo && git commit --author="$GOT_AUTHOR" -q -a "$@")
90 maybe_pack_repo $repo
91 }
93 git_rm()
94 {
95 local repo="$1"
96 shift
97 (cd $repo && git rm -q "$@")
98 }
100 git_show_head()
102 local repo="$1"
103 (cd $repo && git show --no-patch --pretty='format:%H')
106 git_show_branch_head()
108 local repo="$1"
109 local branch="$2"
110 (cd $repo && git show --no-patch --pretty='format:%H' $branch)
114 git_show_author_time()
116 local repo="$1"
117 local object="$2"
118 (cd $repo && git show --no-patch --pretty='format:%at' $object)
121 git_show_tagger_time()
123 local repo="$1"
124 local tag="$2"
125 (cd $repo && git cat-file tag $tag | grep ^tagger | \
126 sed -e "s/^tagger $GOT_AUTHOR//" | cut -d' ' -f2)
129 git_show_parent_commit()
131 local repo="$1"
132 local commit="$2"
133 (cd $repo && git show --no-patch --pretty='format:%P' $commit)
136 git_show_tree()
138 local repo="$1"
139 (cd $repo && git show --no-patch --pretty='format:%T')
142 trim_obj_id()
144 local trimcount=$1
145 local id=$2
147 local pat=""
148 while [ "$trimcount" -gt 0 ]; do
149 pat="[0-9a-f]$pat"
150 trimcount=$((trimcount - 1))
151 done
153 echo ${id%$pat}
156 git_commit_tree()
158 local repo="$1"
159 local msg="$2"
160 local tree="$3"
161 (cd $repo && git commit-tree -m "$msg" "$tree")
164 git_fsck()
166 local testroot="$1"
167 local repo="$2"
169 (cd $repo && git fsck --strict \
170 > $testroot/fsck.stdout 2> $testroot/fsck.stderr)
171 ret="$?"
172 if [ "$ret" != "0" ]; then
173 echo -n "git fsck: "
174 cat $testroot/fsck.stderr
175 echo "git fsck failed; leaving test data in $testroot"
176 return 1
177 fi
179 return 0
182 make_test_tree()
184 repo="$1"
186 echo alpha > $repo/alpha
187 echo beta > $repo/beta
188 mkdir $repo/gamma
189 echo delta > $repo/gamma/delta
190 mkdir $repo/epsilon
191 echo zeta > $repo/epsilon/zeta
194 make_single_file_repo()
196 repo="$1"
197 file="$2"
199 mkdir $repo
200 git_init $repo
201 echo "this is file $file" > $repo/$file
202 (cd $repo && git add .)
203 git_commit $repo -m "intialize $repo with file $file"
206 get_loose_object_path()
208 local repo="$1"
209 local id="$2"
210 local id0=`trim_obj_id 38 $id`
211 local idrest=`echo ${id#[0-9a-f][0-9a-f]}`
212 echo "$repo/.git/objects/$id0/$idrest"
215 get_blob_id()
217 repo="$1"
218 tree_path="$2"
219 filename="$3"
221 got tree -r $repo -i $tree_path | grep "[0-9a-f] ${filename}$" | \
222 cut -d' ' -f 1
225 test_init()
227 local testname="$1"
228 local no_tree="$2"
229 if [ -z "$testname" ]; then
230 echo "No test name provided" >&2
231 return 1
232 fi
233 local testroot=`mktemp -d "$GOT_TEST_ROOT/got-test-$testname-XXXXXXXX"`
234 mkdir $testroot/repo
235 git_init $testroot/repo
236 if [ -z "$no_tree" ]; then
237 make_test_tree $testroot/repo
238 (cd $repo && git add .)
239 git_commit $testroot/repo -m "adding the test tree"
240 fi
241 touch $testroot/repo/.git/git-daemon-export-ok
242 echo "$testroot"
245 test_cleanup()
247 local testroot="$1"
249 git_fsck $testroot $testroot/repo
250 ret="$?"
251 if [ "$ret" != "0" ]; then
252 return $ret
253 fi
255 rm -rf "$testroot"
258 test_parseargs()
260 while getopts qr: flag; do
261 case $flag in
262 q) export GOT_TEST_QUIET=1
263 ;;
264 r) export GOT_TEST_ROOT=$OPTARG
265 ;;
266 ?) echo "Supported options:"
267 echo " -q: quiet mode"
268 echo " -r PATH: use PATH as test data root directory"
269 exit 2
270 ;;
271 esac
272 done
273 } >&2
275 run_test()
277 testfunc="$1"
278 if [ -z "$GOT_TEST_QUIET" ]; then
279 echo -n "$testfunc "
280 fi
281 $testfunc
284 test_done()
286 local testroot="$1"
287 local result="$2"
288 if [ "$result" = "0" ]; then
289 test_cleanup "$testroot" || return 1
290 if [ -z "$GOT_TEST_QUIET" ]; then
291 echo "ok"
292 fi
293 elif echo "$result" | grep -q "^xfail"; then
294 # expected test failure; test reproduces an unfixed bug
295 echo "$result"
296 test_cleanup "$testroot" || return 1
297 else
298 echo "test failed; leaving test data in $testroot"
299 fi